"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyMixins = exports.isString = exports.randName = void 0;
/**
 * random variable name generator
 */
const randName = () => {
    let c1 = Math.floor((Math.random() * 25));
    return 'abcdefghijklmnopqrstuvwxyz'[c1] + '_' + Number(String(Math.random()).substr(2)).toString(36);
};
exports.randName = randName;
/**
 * internal used isString funtion
 */
function isString(obj) {
    return typeof obj === 'string' || obj instanceof String;
}
exports.isString = isString;
/**
 * Add sources methods to dest prototype.
 * Only add method if they do not exists in the destination
 * @param dest Object with prototype to extand
 * @param sources Mixin classes, to merge to the dest prototype
 */
function applyMixins(dest, sources) {
    const destProto = dest.prototype || dest.__proto__;
    for (const baseCtor of sources) {
        const srcProto = baseCtor.prototype || baseCtor.__proto__;
        Object.getOwnPropertyNames(srcProto)
            .filter(name => !destProto[name])
            .forEach(name => {
            const propDef = Object.getOwnPropertyDescriptor(srcProto, name);
            Object.defineProperty(destProto, name, propDef);
        });
    }
    ;
}
exports.applyMixins = applyMixins;
